#include <iostream>
#include <fstream>
using namespace std;

void print_out(double a, double h) {
	ofstream file;
	file.open ("saddle.off");
	file << "OFF\n" << (h + 1) * (h + 1) << " " << h * h << " " << 0;
    for(int i = 0; i <= h; i++) {
    	for(int j = 0; j <= h; j++) {
        	double x = a * (-1 + 2 * i / h);
        	double y = a * (-1 + 2 * j / h);
        	file << "\n" << x << " " << x * x - y * y << " " << y;
    	}
    }
    for(int i = 0; i < h; i++) {
    	for(int j = 0; j < h; j++) {
        	double x = a * (-1 + 2 * i / h);
        	double y = a * (-1 + 2 * j / h);
        	int b = (int(i/h*8)+int(j/h*8))%2*255;
        	file << "\n" << 4 << " " << i*(h+1)+j << " " << i*(h+1)+j+1 << " " << i*(h+1)+h+j+2 << " " << i*(h+1)+h+j+1 << " " << b << " " << b << " " << b;
    	}
    }
	file.close(); 
}

int main () {
	print_out(1, 64);
	return 0;
}
